--- old/usr/src/uts/common/syscall/fcntl.c	2016-07-13 01:32:43.136584305 -0400
+++ new/usr/src/uts/common/syscall/fcntl.c	2016-07-13 01:32:43.146276689 -0400
@@ -179,6 +179,13 @@
 				f_setfd(retval, FD_CLOEXEC);
 			}
 		}
+
+		if (error == 0 && fp->f_vnode != NULL) {
+			(void) VOP_IOCTL(fp->f_vnode, F_ASSOCI_PID,
+			    (intptr_t)p->p_pidp->pid_id, FKIOCTL, kcred,
+			    NULL, NULL);
+		}
+
 		goto done;
 
 	case F_DUP2FD_CLOEXEC:
@@ -215,6 +222,17 @@
 			fp->f_count++;
 			mutex_exit(&fp->f_tlock);
 			releasef(fdes);
+
+			/*
+			 * Assume we succeed to duplicate the file descriptor
+			 * and associate the pid to the vnode.
+			 */
+			if (fp->f_vnode != NULL) {
+				(void) VOP_IOCTL(fp->f_vnode, F_ASSOCI_PID,
+				    (intptr_t)p->p_pidp->pid_id, FKIOCTL,
+				    kcred, NULL, NULL);
+			}
+
 			if ((error = closeandsetf(iarg, fp)) == 0) {
 				if (cmd == F_DUP2FD_CLOEXEC) {
 					f_setfd(iarg, FD_CLOEXEC);
@@ -225,6 +243,17 @@
 				if (fp->f_count > 1) {
 					fp->f_count--;
 					mutex_exit(&fp->f_tlock);
+					/*
+					 * Failed to duplicate fdes,
+					 * disassociate the pid from the vnode.
+					 */
+					if (fp->f_vnode != NULL) {
+						(void) VOP_IOCTL(fp->f_vnode,
+						    F_DASSOC_PID,
+						    (intptr_t)p->p_pidp->pid_id,
+						    FKIOCTL, kcred, NULL, NULL);
+					}
+
 				} else {
 					mutex_exit(&fp->f_tlock);
 					(void) closef(fp);
